POJ 3723 Conscription (求最大权森林,kruskal,并查集)

2024-02-07 17:58

本文主要是介绍POJ 3723 Conscription (求最大权森林,kruskal,并查集),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接: http://poj.org/problem?id=3723

题意:要征募女兵N人,男兵M人。每征一个花10000,有亲密关系则可以省相应的钱。给出R条关系以及可以省的钱。求最小花费。

输入:
2

5 5 8
4 3 6831
1 3 4583
0 0 6592
0 1 3063
3 3 4975
1 3 2049
4 2 2104
2 2 781

5 5 10
2 4 9820
3 2 6236
3 1 8864
2 4 8326
2 0 5156
2 0 1463
4 1 2439
0 4 4373
3 4 8889
2 4 3133

输出:
71071
54223


———挑战程序设计竞赛
图有可能不联通,也就是说其实是求图的最大权森林,这里的二分图是一个多余的条件。
求最大权森林也可以用Kruskal来做。
可以先将权值全部取反,这样就转化为求最小权森林。
求出后加上这个最小权值即可。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <queue>
#include <vector>
using namespace std;
const int MAX_N = 22222; //男兵和女兵总数
const int MAX_E = 55555; 
int f[MAX_N];
int h[MAX_N]; //记录树的高度避免退化
int N, M, R;void init(int n)  {int i;for(i = 0; i < n; i++) {f[i] = i;h[i] = 0;}
}int find(int x) {if(f[x] == x) return x;else return f[x] = find(f[x]);
}void unite(int x, int y) {x = find(x);y = find(y);if(x != y) {if(h[x] < h[y]) f[x] = y;else {f[y] = x;if(h[x] == h[y]) h[x]++;  //高度变化 }}
}
bool same(int x, int y) {return find(x) == find(y);
}struct edge{int from, to, cost;
};bool cmp(edge a, edge b) {return a.cost < b.cost;
}edge es[MAX_E];int kruskal() {sort(es, es + R, cmp);init(N + M);int res = 0;int i;for(i = 0; i < R; i++) {edge e = es[i];if(!same(e.from, e.to)) {unite(e.from, e.to);res += e.cost;}}return res;
}int main() {int t;scanf("%d", &t);while(t--) {scanf("%d %d %d", &N, &M, &R);int i;int x, y, z;for(i = 0; i < R; i++) {scanf("%d %d %d", &x, &y, &z);z = -z; //转换为求最小权森林 es[i].from = x, es[i].to = y + N, es[i].cost = z;  //注意对节点重新编号 }printf("%d\n", 10000 * (N + M) + kruskal());}return 0;
}






图有可能不联通,关键是理解题意,用没优惠之前的价格减去最大生成树即可得到答案。
参考博客: http://blog.csdn.net/y990041769/article/details/41773699
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <stack> 
#include <cstring>
#define eps 1e-8
using namespace std; 
int N, M, R;
int u[50010], v[50010], w[50010];
int p[50010], father[50010];
bool cmp(int a, int b) {return w[a] > w[b];
}
int find(int x)  
{  if(father[x]==x)  return x;  return father[x] = find(father[x]);  	//压缩路径 
} 
int kruskal() {int i;int sumd = 0;for(i = 0; i < R; i++) p[i] = i;for(i = 0; i < N + M; i++) father[i] = i;sort(p, p + R, cmp);for(i = 0; i < R; i++) {int e = p[i];int x = find(u[e]);int y = find(v[e]);if(x != y) {sumd += w[e];father[x] = y;}}return sumd;
}
int main() {int T;scanf("%d", &T);while(T--) {scanf("%d %d %d", &N, &M, &R);int i;int x;for(i = 0; i < R; i++) {scanf("%d %d %d", &u[i], &x, &w[i]);    //给每个点重新编号v[i] = N + x;}int sumd = kruskal();printf("%d\n", (M + N) * 10000 - sumd);}return 0;
}


这篇关于POJ 3723 Conscription (求最大权森林,kruskal,并查集)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/688497

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i